<?php

require_once './settings.php';
require_once FLASHCOMS_ROOT.'common/server/php/core/core.php';

Clear();

if(!isset($_REQUEST["action"])) $_REQUEST["action"] = '';
switch($_REQUEST["action"])
{
    case 'upload':   SaveFile();  break;
    case 'download': GetFile();   break;
    case 'image':    SaveImage(); break;
    default: EchoError('INVALID_ARGUMENTS');
}

function SaveFile()
{
    if(!isset($_FILES['Filedata']))  EchoError('NO_FILE_SENDED');
    if(!isset($_REQUEST['fileId'])) EchoError('NO_FILE_ID_DEFINED');

    $name = FILES_DIR.MakeFileName($_REQUEST["fileId"]);
    if(file_exists($name)) EchoError('FILE_EXISTS_ALREADY');

    if(move_uploaded_file($_FILES['Filedata']['tmp_name'], $name)) 
    {
    	chmod($name, 0755);
	    EchoResult("UPLOAD_SUCCESS");
    }
    else EchoError('CANT_SAVE_FILE');
}

function SaveImage()
{
    if(!isset($_FILES['Filedata'])) EchoError('NO_FILE_SENDED');
    if(!isset($_REQUEST['fileId'])) EchoError('NO_FILE_ID_DEFINED');
    
    $ext = strtolower(array_pop(explode('.', $_FILES['Filedata']['name'])));
    if(!in_array($ext, array('jpeg','jpg','gif','png'))) EchoResult('INVALID FILE TYPE');

    $name = FILES_DIR.MakeFileName($_REQUEST["fileId"]);
    $thumbnail = $name.'_s.'.$ext;
    $name .= '.'.$ext;
    if(file_exists($name)) EchoError('FILE_EXISTS_ALREADY');

    if(move_uploaded_file($_FILES['Filedata']['tmp_name'], $name)) 
    {
    	chmod($name, 0755);
    	
    	require_once FLASHCOMS_ROOT.'common/server/php/core/imagelibrary.class.php';
		$ImageLibrary->Resize($name, $thumbnail, 62, 43, true, true);
    	
		EchoResult("UPLOAD_SUCCESS");
    }
    else EchoError('CANT_SAVE_FILE');
}

function GetFile()
{
    if(!isset($_REQUEST['fileId'])) EchoError('NO_FILE_ID_DEFINED');
    $name = FILES_DIR.MakeFileName($_REQUEST["fileId"]);
    if(!file_exists($name))
    {
        header("HTTP/1.1 404 Not Found");
        exit;
    }

    header("Content-Length: " . filesize($name));
    readfile($name);
    @unlink($name);
}

function Clear()
{
    if($handle = @opendir(FILES_DIR))
    {
        while(false !== ($file = @readdir($handle)))
        {
            if(is_file(FILES_DIR.$file))
            {
                if(@filemtime(FILES_DIR.$file) < (time() - FILE_KEEP_TIME))
                {
                    @unlink(FILES_DIR.$file);
                }
            }
        }
        @closedir($handle);
    }
}

function MakeFileName($name)
{
    $name = str_replace(".", "_", $name);
    $name = str_replace("/", "_", $name);
    $name = str_replace("\\", "_", $name);
    $name = str_replace(" ", "_", $name);
    return $name;
}

function EchoError($err_string)
{
	header("Content-type: text/xml");
    $res = '<answer error="1" msg="'.$err_string.'" />';
    echo $res;
    exit;
}

function EchoResult($msg)
{
	header("Content-type: text/xml");
    $res = '<answer error="0" msg="'.$msg.'" />';
    echo $res;
    exit;
}

?>